// Copyright 2023 Undistro Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package printers

import (
	"encoding/json"
	"io"

	"github.com/undistro/marvin/pkg/types"
)

// JSONPrinter implements a Printer that prints the report in JSON format
type JSONPrinter struct{}

func (*JSONPrinter) PrintObj(report types.Report, w io.Writer) error {
	data, err := json.Marshal(report)
	if err != nil {
		return err
	}
	data = append(data, '\n')
	_, err = w.Write(data)
	return err
}
